
from random import randint

q = 18434813901432784897 # 64-bit: prime q
R = 18446744073709551616 # 2^64
Rv= 14039819647447147690 # 64-bit: R^-1 (mod q)
mu= 14048905579533273087 # 64-bit: (−q)^−1 (mod R)

def montgomery(C):
    m = (C * mu) % R
    u = C + m*q
    u = u >> 64 # u/R
    D = u - q if(u >= q) else u
    return D

# Test

A = randint(0, q-1)
B = randint(0, q-1)

C = A * B

D = montgomery(C)
D_expected = C*Rv % q

print("D:", D, "D_expected:", D_expected, "D == D_expected ?:", D == D_expected)


